# Recurify

[![Gem Version](https://badge.fury.io/rb/recurify.svg)](https://badge.fury.io/rb/recurify)
[![Build Status](https://img.shields.io/travis/cs/recurify/master.svg)](https://travis-ci.org/cs/recurify)
[![Code Climate](https://codeclimate.com/github/cs/recurify/badges/gpa.svg)](https://codeclimate.com/github/cs/recurify)

**Recurify is very much "work in progress" and shoudn't be used yet.**

Recurify is a simple, light-weight, evaluator for Recurrence Rules. It takes a
`Rule` as input and returns an [`Enumerable`][enumerable], yielding all
occurrences (i.e. simple [`Date`][date] objects) resulting from the `Rule`'s
evaluation in chronlogical order.

[enumerable]: http://ruby-doc.org/core-2.2.3/Enumerable.html
[date]: http://ruby-doc.org/stdlib-2.2.3/libdoc/date/rdoc/Date.html

## Contributions

1. **Everything has to be tested.** No excuses. Pending tests are forbidden.
2. Ensure the project's test suite is still passing (run `rspec`).
3. Ensure the code is still passing all rubocop checks (run `rubocop`).
4. Document your changes.
5. All commits messages have to be prefixed as follows:
   * `F` - **F**eature commits with functional changes.  
     Example commit message: `F implement Rule#normalize`.
   * `B` - **B**ugfix commits for fixing broken stuff.  
     Example commit message: `B consider Rule#count in Rule#==`.
   * `R` - **R**efactoring commits without functional changes.  
     Example commit message: `R memoize Rule#normalize for performance`.
   * `C` - **C**hore commits are for everything else.  
     Example commit message: `C bump version to 1.0.0`.

Prefixed commit messages may seem a bit strange at first. The intention is
simply to keep functional and non-functional changes clearly apart. Therefore,
`R` and `C` commits must **never** modify the code in `lib` and in `spec` at the
same time.

## Sponsor

Recurify is sponsored by [Shore][shore]. They are currently [hiring][shore-jobs]
Ruby, JavaScript, iOS, and Android developers for their headquarters in
Munich/Germany as well as their top-notch development teams in Sofia/Bulgaria
and Madrid/Spain.

[shore]: http://www.shore.com
[shore-jobs]: http://www.shore.com/en/careers

## License

See [LICENSE](https://github.com/cs/recurify/blob/master/LICENSE).
